function err = Mito_full_ode_fit(exp_t, exp_y,exp_atp, exp_gag, p)
%A function for fitting the MDR mito model (without E and U).
%exp_t is experimental time points
%exp_y is experimental values for the different variables
%p is the vector of parameters
kS = p(1); dD = p(2); dR = p(3); sC = p(4); R7 = p(5); %R14 = p(6);
kE = p(6); lE = p(7); 
%dU = p(9);
kU = p(8); lU = p(9);
  %kD = 2;
kD = p(10);
alpha = p(11); sR = p(12);
%aM = dR/1.1;
aM = dR;
dE = kE/(lE*(1+lE));dU = 0;
%kU = (1 + lU)*dU;
R0 = 1/(1 + 0.00001);
options = odeset('RelTol',1e-4,'AbsTol',[1e-4 1e-4 1e-4 1e-4 1e-4 1e-4]);
%[T7,Y7] = ode15s(@(t,y) Mito_full_ode(t,y,kS,dD,aM,kD,dR,sC,kE,lE,R0,dE,kU,dU,lU),exp_t,[0.9,0.1,R7,1,1],options);
%[~,Y14] = ode15s(@(t,y) Mito_full_ode(t,y,kS,dD,aM,kD,dR,sC,kE,lE,R0,dE,kU,dU,lU),exp_t,[0.65,0.35,R14,1,1],options);
[T7,Y7] = ode15s(@(t,y) Mito_full_ode(t,y,kS,dD,aM,kD,dR,sC,kE,lE,R0,dE,kU,dU,lU,alpha,sR),exp_t,[1.0,0.0,R7,1,1,0],options);
%[T14,Y14] = ode15s(@(t,y) Mito_full_ode(t,y,kS,dD,aM,kD,dR,sC,kE,lE,R0,dE,kU,dU,lU),exp_t,[0.9,0.1,R14,1,1],options);
%plot(T7,(Y7(:,1) + Y7(:,2)),exp_t(1:8),exp_y(2,:));
t7 = zeros(length(exp_t));
%Gather the indeces at the experimental time points (unnecessary for ode solved at particular times). Still, I use to avoid any shenanigans.
for i = 1:length(exp_t)
    [~,I] = min(abs(T7 - exp_t(i)));
    t7(i) = I;
end
err = 0.0;
%Calculate viability error, no viability data for the last two time points
length_t = length(exp_t) - 2;
for i = 1:length_t
%err = err + (Y7(t7(i),1) + Y7(t7(i),2) - exp_y(1,i)).^2 + (Y14(t7(i),1) + Y14(t7(i),2) - exp_y(2,i)).^2;
	%try
	err = err + (Y7(i,1) + Y7(i,2) - exp_y(1,i))^2;
	%err = err + (Y14(i,1) + Y14(i,2) - exp_y(2,i)).^2;
	%catch
	%Y7
	%Y14
	%p
	%end
end
%add the atp error (@ t = 24 and 48)
err = err + (Y7(6,4) - exp_atp(1))^2 + (Y7(7,4) - exp_atp(2))^2;

%add the gag error (@ t = 168, 336)
err = err + (Y7(9,5) - exp_gag(1))^2 + (Y7(10,5) - exp_gag(2))^2;
