% Run the parameter estimation with paticle swarm

exp_t = [1,2,4,6,12,24,48, 72, 168, 336]; %Time points from experimental data
exp_y = [0.71, 0.66, 0.53, 0.58, 0.45, 0.46, 0.42, 0.46;
     0.65, 0.63, 0.53, 0.38, 0.37, 0.35, 0.35, 0.39]./0.89;%Values from Experimental data. Must match the time points - 2.
exp_atp = [0.18, 0.31];
exp_gag = [0.81, 0.87];
data_size = length(exp_y(1,:)) + length(exp_y(2,:)) + length(exp_atp) + length(exp_gag);
options = optimoptions('particleswarm','SwarmSize',1000,'MaxIter',50,'HybridFcn',@fmincon);
%variable order: kS, dD, dR, sC, R7, kE, lE, kU, lU, kD, alpha, sR
%define parameter lower bounds
%lb = [1,1,0.1,1, 1.0, 1,0.01,0.01,1,0.2,1,5,0.01];
lb = [0.1,0.1,0.1,1, 1.0, 0.1,0.1,0.1,0.1,1,1,0.1];
%define parameter upper bounds
%ub = [10,10,2,2, 2, 1.2,0.5,0.5,10,0.5,3,10];
ub = [10,10,10,15, 3, 10,10,10,10,3,10,1];
[p_estimate,f_err] = particleswarm(@(p)Mito_full_ode_fit(exp_t,exp_y,exp_atp,exp_gag,p),12,lb,ub,options);
%[p_estimate,f_err] = particleswarm(@(p)Mito_full_ode_fit14(exp_t,exp_y,exp_atp,exp_gag,p),1,1.0202,1.1,options);
%fileID1 = fopen('parameter_fit_results.txt','w');
%fprintf(fileID1, '%12s %2.4f\n ', 'R14 = ', p_estimate);
%fprintf(fileID1, '%12s %2.4f\n ', 'error (total) = ', f_err);
%fclose(fileID1);
%Mito_full_ode_fit(exp_t,exp_y,exp_atp,exp_gag,[3,3,0.18,3,1,1,0.37,0.5,3.42,0.3]);


fileID1 = fopen('parameter_fit_results.txt','w');
fprintf(fileID1, '%12s %2.4f\n ', 'kS = ' ,p_estimate(1));
fprintf(fileID1, '%12s %2.4f\n ', 'dD = ', p_estimate(2));
fprintf(fileID1, '%12s %2.4f\n ', 'dR = ', p_estimate(3));
fprintf(fileID1, '%12s %2.4f\n ', 'sC = ',p_estimate(4));
fprintf(fileID1, '%12s %2.4f\n ', 'R7 = ', p_estimate(5));
%fprintf(fileID1, '%12s %2.4f\n ', 'R14 = ', p_estimate(6));
fprintf(fileID1, '%12s %2.4f\n ', 'kE = ' ,p_estimate(6));
fprintf(fileID1, '%12s %2.4f\n ', 'lE = ' ,p_estimate(7));
%fprintf(fileID1, '%12s %2.4f\n ', 'dU = ' ,p_estimate(9));
fprintf(fileID1, '%12s %2.4f\n ', 'kU = ' ,p_estimate(8));
fprintf(fileID1, '%12s %2.4f\n ', 'lU = ' ,p_estimate(9));
fprintf(fileID1, '%12s %2.4f\n ', 'kD = ' ,p_estimate(10));
fprintf(fileID1, '%12s %2.4f\n ', 'alpha = ' ,p_estimate(11));
fprintf(fileID1, '%12s %2.4f\n ', 'sR = ' ,p_estimate(12));
fprintf(fileID1, '%12s %2.4f\n ', 'error (total) = ', f_err);
fclose(fileID1);

